Linux kernel mirror (for testing)
git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
kernel
os
linux
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12# ^
13# |
14# +--< vmlinux.a
15# |
16# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34VMLINUX="$4"
35
36is_enabled() {
37 grep -q "^$1=y" include/config/auto.conf
38}
39
40# Nice output in kbuild format
41# Will be supressed by "make -s"
42info()
43{
44 printf " %-7s %s\n" "${1}" "${2}"
45}
46
47# Link of vmlinux
48# ${1} - output file
49vmlinux_link()
50{
51 local output=${1}
52 local objs
53 local libs
54 local ld
55 local ldflags
56 local ldlibs
57
58 info LD ${output}
59
60 # skip output file argument
61 shift
62
63 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT ||
64 is_enabled CONFIG_KLP_BUILD; then
65 # Use vmlinux.o instead of performing the slow LTO link again.
66 objs=vmlinux.o
67 libs=
68 else
69 objs=vmlinux.a
70 libs="${KBUILD_VMLINUX_LIBS}"
71 fi
72
73 if is_enabled CONFIG_GENERIC_BUILTIN_DTB; then
74 objs="${objs} .builtin-dtbs.o"
75 fi
76
77 objs="${objs} .vmlinux.export.o"
78 objs="${objs} init/version-timestamp.o"
79
80 if [ "${SRCARCH}" = "um" ]; then
81 wl=-Wl,
82 ld="${CC}"
83 ldflags="${CFLAGS_vmlinux}"
84 ldlibs="-lutil -lrt -lpthread"
85 else
86 wl=
87 ld="${LD}"
88 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
89 ldlibs=
90 fi
91
92 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
93
94 # The kallsyms linking does not need debug symbols included.
95 if [ -n "${strip_debug}" ] ; then
96 ldflags="${ldflags} ${wl}--strip-debug"
97 fi
98
99 if [ -n "${generate_map}" ]; then
100 ldflags="${ldflags} ${wl}-Map=vmlinux.map"
101 fi
102
103 ${ld} ${ldflags} -o ${output} \
104 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
105 ${wl}--start-group ${libs} ${wl}--end-group \
106 ${kallsymso} ${btf_vmlinux_bin_o} ${arch_vmlinux_o} ${ldlibs}
107}
108
109# Create ${2}.o file with all symbols from the ${1} object file
110kallsyms()
111{
112 local kallsymopt;
113
114 if is_enabled CONFIG_KALLSYMS_ALL; then
115 kallsymopt="${kallsymopt} --all-symbols"
116 fi
117
118 if is_enabled CONFIG_64BIT || is_enabled CONFIG_RELOCATABLE; then
119 kallsymopt="${kallsymopt} --pc-relative"
120 fi
121
122 info KSYMS "${2}.S"
123 scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
124
125 info AS "${2}.o"
126 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
127 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
128
129 kallsymso=${2}.o
130}
131
132# Perform kallsyms for the given temporary vmlinux.
133sysmap_and_kallsyms()
134{
135 mksysmap "${1}" "${1}.syms"
136 kallsyms "${1}.syms" "${1}.kallsyms"
137
138 kallsyms_sysmap=${1}.syms
139}
140
141# Create map file with all symbols from ${1}
142# See mksymap for additional details
143mksysmap()
144{
145 info NM ${2}
146 ${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
147}
148
149sorttable()
150{
151 ${NM} -S ${1} > .tmp_vmlinux.nm-sort
152 ${objtree}/scripts/sorttable -s .tmp_vmlinux.nm-sort ${1}
153}
154
155cleanup()
156{
157 rm -f .btf.*
158 rm -f .tmp_vmlinux.nm-sort
159 rm -f System.map
160 rm -f vmlinux
161 rm -f vmlinux.map
162}
163
164# Use "make V=1" to debug this script
165case "${KBUILD_VERBOSE}" in
166*1*)
167 set -x
168 ;;
169esac
170
171if [ "$1" = "clean" ]; then
172 cleanup
173 exit 0
174fi
175
176${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
177
178arch_vmlinux_o=
179if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
180 arch_vmlinux_o=arch/${SRCARCH}/tools/vmlinux.arch.o
181fi
182
183btf_vmlinux_bin_o=
184btfids_vmlinux=
185kallsymso=
186strip_debug=
187generate_map=
188
189# Use "make UT=1" to trigger warnings on unused tracepoints
190case "${WARN_ON_UNUSED_TRACEPOINTS}" in
191*1*)
192 ${objtree}/scripts/tracepoint-update vmlinux.o
193 ;;
194esac
195
196if is_enabled CONFIG_KALLSYMS; then
197 true > .tmp_vmlinux0.syms
198 kallsyms .tmp_vmlinux0.syms .tmp_vmlinux0.kallsyms
199fi
200
201if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
202
203 # The kallsyms linking does not need debug symbols, but the BTF does.
204 if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
205 strip_debug=1
206 fi
207
208 vmlinux_link .tmp_vmlinux1
209fi
210
211if is_enabled CONFIG_DEBUG_INFO_BTF; then
212 info BTF .tmp_vmlinux1
213 if ! ${CONFIG_SHELL} ${srctree}/scripts/gen-btf.sh .tmp_vmlinux1; then
214 echo >&2 "Failed to generate BTF for vmlinux"
215 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
216 exit 1
217 fi
218 btf_vmlinux_bin_o=.tmp_vmlinux1.btf.o
219 btfids_vmlinux=.tmp_vmlinux1.BTF_ids
220fi
221
222if is_enabled CONFIG_KALLSYMS; then
223
224 # kallsyms support
225 # Generate section listing all symbols and add it into vmlinux
226 # It's a four step process:
227 # 0) Generate a dummy __kallsyms with empty symbol list.
228 # 1) Link .tmp_vmlinux1.kallsyms so it has all symbols and sections,
229 # with a dummy __kallsyms.
230 # Running kallsyms on that gives us .tmp_vmlinux1.kallsyms.o with
231 # the right size
232 # 2) Link .tmp_vmlinux2.kallsyms so it now has a __kallsyms section of
233 # the right size, but due to the added section, some
234 # addresses have shifted.
235 # From here, we generate a correct .tmp_vmlinux2.kallsyms.o
236 # 3) That link may have expanded the kernel image enough that
237 # more linker branch stubs / trampolines had to be added, which
238 # introduces new names, which further expands kallsyms. Do another
239 # pass if that is the case. In theory it's possible this results
240 # in even more stubs, but unlikely.
241 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
242 # other bugs.
243 # 4) The correct ${kallsymso} is linked into the final vmlinux.
244 #
245 # a) Verify that the System.map from vmlinux matches the map from
246 # ${kallsymso}.
247
248 # The kallsyms linking does not need debug symbols included.
249 strip_debug=1
250
251 sysmap_and_kallsyms .tmp_vmlinux1
252 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
253
254 vmlinux_link .tmp_vmlinux2
255 sysmap_and_kallsyms .tmp_vmlinux2
256 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
257
258 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
259 vmlinux_link .tmp_vmlinux3
260 sysmap_and_kallsyms .tmp_vmlinux3
261 fi
262fi
263
264strip_debug=
265
266if is_enabled CONFIG_VMLINUX_MAP; then
267 generate_map=1
268fi
269
270vmlinux_link "${VMLINUX}"
271
272if is_enabled CONFIG_DEBUG_INFO_BTF; then
273 info BTFIDS ${VMLINUX}
274 ${RESOLVE_BTFIDS} --patch_btfids ${btfids_vmlinux} ${VMLINUX}
275fi
276
277mksysmap "${VMLINUX}" System.map
278
279if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
280 info SORTTAB "${VMLINUX}"
281 if ! sorttable "${VMLINUX}"; then
282 echo >&2 Failed to sort kernel tables
283 exit 1
284 fi
285fi
286
287# step a (see comment above)
288if is_enabled CONFIG_KALLSYMS; then
289 if ! cmp -s System.map "${kallsyms_sysmap}"; then
290 echo >&2 Inconsistent kallsyms data
291 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
292 exit 1
293 fi
294fi
295
296# For fixdep
297echo "${VMLINUX}: $0" > ".${VMLINUX}.d"